diff --git a/src/polkitbackend/polkitbackendjsauthority.c b/src/polkitbackend/polkitbackendjsauthority.c
index 2112868..f6d3694 100644
--- a/src/polkitbackend/polkitbackendjsauthority.c
+++ b/src/polkitbackend/polkitbackendjsauthority.c
@@ -1175,15 +744,10 @@ polkit_backend_js_authority_get_admin_auth_identities (PolkitBackendInteractiveA
 
  out:
   g_strfreev (ret_strs);
-  g_free (ret_str);
   /* fallback to root password auth */
   if (ret == NULL)
     ret = g_list_prepend (ret, polkit_unix_user_new (0));
 
-  JS_MaybeGC (authority->priv->cx);
-
-  JS_EndRequest (authority->priv->cx);
-
   return ret;
 }
 
@@ -1202,17 +766,16 @@ polkit_backend_js_authority_check_authorization_sync (PolkitBackendInteractiveAu
 {
   PolkitBackendJsAuthority *authority = POLKIT_BACKEND_JS_AUTHORITY (_authority);
   PolkitImplicitAuthorization ret = implicit;
-  jsval argv[2] = {JSVAL_NULL, JSVAL_NULL};
-  jsval rval = JSVAL_NULL; 
   GError *error = NULL;
-  JSString *ret_jsstr;
-  const jschar *ret_utf16;
   gchar *ret_str = NULL;
   gboolean good = FALSE;
+  duk_context *cx = authority->priv->cx;
 
-  JS_BeginRequest (authority->priv->cx);
+  duk_set_top (cx, 0);
+  duk_get_global_string (cx, "polkit");
+  duk_push_string (cx, "_runRules");
 
-  if (!action_and_details_to_jsval (authority, action_id, details, &argv[0], &error))
+  if (!push_action_and_details (cx, action_id, details, &error))
     {
       polkit_backend_authority_log (POLKIT_BACKEND_AUTHORITY (authority),
                                     "Error converting action and details to JS object: %s",
@@ -1221,13 +784,7 @@ polkit_backend_js_authority_check_authorization_sync (PolkitBackendInteractiveAu
       goto out;
     }
 
-  if (!subject_to_jsval (authority,
-                         subject,
-                         user_for_subject,
-                         subject_is_local,
-                         subject_is_active,
-                         &argv[1],
-                         &error))
+  if (!push_subject (cx, subject, user_for_subject, subject_is_local, subject_is_active, &error))
     {
       polkit_backend_authority_log (POLKIT_BACKEND_AUTHORITY (authority),
                                     "Error converting subject to JS object: %s",
@@ -1236,39 +793,16 @@ polkit_backend_js_authority_check_authorization_sync (PolkitBackendInteractiveAu
       goto out;
     }
 
-  if (!call_js_function_with_runaway_killer (authority,
-                                             "_runRules",
-                                             G_N_ELEMENTS (argv),
-                                             argv,
-                                             &rval))
+  mark_start_time (authority);
+  if (duk_pcall_prop (cx, 0, 2) != DUK_ERR_NONE)
     {
       polkit_backend_authority_log (POLKIT_BACKEND_AUTHORITY (authority),
-                                    "Error evaluating authorization rules");
-      goto out;
-    }
-
-  if (JSVAL_IS_NULL (rval))
-    {
-      /* this fine, means there was no match, use implicit authorizations */
-      good = TRUE;
+                                    "Error evaluating authorization rules: ",
+                                    duk_safe_to_string (cx, -1));
       goto out;
     }
 
-  if (!JSVAL_IS_STRING (rval))
-    {
-      g_warning ("Expected a string");
-      goto out;
-    }
-
-  ret_jsstr = JSVAL_TO_STRING (rval);
-  ret_utf16 = JS_GetStringCharsZ (authority->priv->cx, ret_jsstr);
-  ret_str = g_utf16_to_utf8 (ret_utf16, -1, NULL, NULL, &error);
-  if (ret_str == NULL)
-    {
-      g_warning ("Error converting resulting string to UTF-8: %s", error->message);
-      g_clear_error (&error);
-      goto out;
-    }
+  ret_str = g_strdup (duk_require_string (cx, -1));
 
   g_strstrip (ret_str);
   if (!polkit_implicit_authorization_from_string (ret_str, &ret))
@@ -1286,37 +820,17 @@ polkit_backend_js_authority_check_authorization_sync (PolkitBackendInteractiveAu
     ret = POLKIT_IMPLICIT_AUTHORIZATION_NOT_AUTHORIZED;
   g_free (ret_str);
 
-  JS_MaybeGC (authority->priv->cx);
-
-  JS_EndRequest (authority->priv->cx);
-
   return ret;
 }
 
 /* ---------------------------------------------------------------------------------------------------- */
 
-static JSBool
-js_polkit_log (JSContext  *cx,
-               unsigned    argc,
-               jsval      *vp)
+static duk_ret_t
+js_polkit_log (duk_context *cx)
 {
-  /* PolkitBackendJsAuthority *authority = POLKIT_BACKEND_JS_AUTHORITY (JS_GetContextPrivate (cx)); */
-  JSBool ret = JS_FALSE;
-  JSString *str;
-  char *s;
-
-  if (!JS_ConvertArguments (cx, argc, JS_ARGV (cx, vp), "S", &str))
-    goto out;
-
-  s = JS_EncodeString (cx, str);
-  JS_ReportWarning (cx, s);
-  JS_free (cx, s);
-
-  ret = JS_TRUE;
-
-  JS_SET_RVAL (cx, vp, JSVAL_VOID);  /* return undefined */
- out:
-  return ret;
+  const char *str = duk_require_string (cx, 0);
+  fprintf (stderr, "%s\n", str);
+  return 0;
 }
 
 /* ---------------------------------------------------------------------------------------------------- */
@@ -1380,54 +894,33 @@ spawn_cb (GObject       *source_object,
   g_main_loop_quit (data->loop);
 }
 
-static JSBool
-js_polkit_spawn (JSContext  *cx,
-                 unsigned    js_argc,
-                 jsval      *vp)
+static duk_ret_t
+js_polkit_spawn (duk_context *cx)
 {
-  /* PolkitBackendJsAuthority *authority = POLKIT_BACKEND_JS_AUTHORITY (JS_GetContextPrivate (cx)); */
-  JSBool ret = JS_FALSE;
-  JSObject *array_object;
+  duk_ret_t ret = DUK_RET_INTERNAL_ERROR;
   gchar *standard_output = NULL;
   gchar *standard_error = NULL;
   gint exit_status;
   GError *error = NULL;
-  JSString *ret_jsstr;
   guint32 array_len;
   gchar **argv = NULL;
   GMainContext *context = NULL;
   GMainLoop *loop = NULL;
   SpawnData data = {0};
+  char *err_str = NULL;
   guint n;
 
-  if (!JS_ConvertArguments (cx, js_argc, JS_ARGV (cx, vp), "o", &array_object))
+  if (!duk_is_array (cx, 0))
     goto out;
 
-  if (!JS_GetArrayLength (cx, array_object, &array_len))
-    {
-      JS_ReportError (cx, "Failed to get array length");
-      goto out;
-    }
+  array_len = duk_get_length (cx, 0);
 
   argv = g_new0 (gchar*, array_len + 1);
   for (n = 0; n < array_len; n++)
     {
-      jsval elem_val;
-      char *s;
-
-      if (!JS_GetElement (cx, array_object, n, &elem_val))
-        {
-          JS_ReportError (cx, "Failed to get element %d", n);
-          goto out;
-        }
-      if (!JSVAL_IS_STRING (elem_val))
-	{
-          JS_ReportError (cx, "Element %d is not a string", n);
-          goto out;
-	}
-      s = JS_EncodeString (cx, JSVAL_TO_STRING (elem_val));
-      argv[n] = g_strdup (s);
-      JS_free (cx, s);
+      duk_get_prop_index (cx, 0, n);
+      argv[n] = g_strdup (duk_to_string (cx, -1));
+      duk_pop (cx);
     }
 
   context = g_main_context_new ();
@@ -1452,9 +945,8 @@ js_polkit_spawn (JSContext  *cx,
                            &standard_error,
                            &error))
     {
-      JS_ReportError (cx,
-                      "Error spawning helper: %s (%s, %d)",
-                      error->message, g_quark_to_string (error->domain), error->code);
+      err_str = g_strdup_printf ("Error spawning helper: %s (%s, %d)",
+                                 error->message, g_quark_to_string (error->domain), error->code);
       g_clear_error (&error);
       goto out;
     }
@@ -1478,15 +970,12 @@ js_polkit_spawn (JSContext  *cx,
         }
       g_string_append_printf (gstr, ", stdout=`%s', stderr=`%s'",
                               standard_output, standard_error);
-      JS_ReportError (cx, gstr->str);
-      g_string_free (gstr, TRUE);
+      err_str = g_string_free (gstr, FALSE);
       goto out;
     }
 
-  ret = JS_TRUE;
-
-  ret_jsstr = JS_NewStringCopyZ (cx, standard_output);
-  JS_SET_RVAL (cx, vp, STRING_TO_JSVAL (ret_jsstr));
+  duk_push_string (cx, standard_output);
+  ret = 1;
 
  out:
   g_strfreev (argv);
@@ -1497,51 +986,38 @@ js_polkit_spawn (JSContext  *cx,
     g_main_loop_unref (loop);
   if (context != NULL)
     g_main_context_unref (context);
+
+  if (err_str)
+    duk_error (cx, DUK_ERR_ERROR, err_str);
+
   return ret;
 }
 
 /* ---------------------------------------------------------------------------------------------------- */
 
 
-static JSBool
-js_polkit_user_is_in_netgroup (JSContext  *cx,
-                               unsigned    argc,
-                               jsval      *vp)
+static duk_ret_t
+js_polkit_user_is_in_netgroup (duk_context *cx)
 {
-  /* PolkitBackendJsAuthority *authority = POLKIT_BACKEND_JS_AUTHORITY (JS_GetContextPrivate (cx)); */
-  JSBool ret = JS_FALSE;
-  JSString *user_str;
-  JSString *netgroup_str;
-  char *user;
-  char *netgroup;
-  JSBool is_in_netgroup = JS_FALSE;
-
-  if (!JS_ConvertArguments (cx, argc, JS_ARGV (cx, vp), "SS", &user_str, &netgroup_str))
-    goto out;
+  const char *user;
+  const char *netgroup;
+  gboolean is_in_netgroup = FALSE;
 
-  user = JS_EncodeString (cx, user_str);
-  netgroup = JS_EncodeString (cx, netgroup_str);
+  user = duk_require_string (cx, 0);
+  netgroup = duk_require_string (cx, 1);
 
   if (innetgr (netgroup,
                NULL,  /* host */
                user,
                NULL)) /* domain */
     {
-      is_in_netgroup =  JS_TRUE;
+      is_in_netgroup = TRUE;
     }
 
-  JS_free (cx, netgroup);
-  JS_free (cx, user);
-
-  ret = JS_TRUE;
-
-  JS_SET_RVAL (cx, vp, BOOLEAN_TO_JSVAL (is_in_netgroup));
- out:
-  return ret;
+  duk_push_boolean (cx, is_in_netgroup);
+  return 1;
 }
 
-
-
 /* ---------------------------------------------------------------------------------------------------- */
 
 typedef struct
@@ -1917,3 +1393,27 @@ utils_spawn_finish (GAsyncResult   *res,
  out:
   return ret;
 }
+
+int
+polkit_js_exec_timeout_check (const void *udata)
+{
+  PolkitBackendJsAuthority *authority = (void *) udata;
+
+  gint64 current_time = g_get_monotonic_time ();
+  gint64 elapsed_time = current_time - authority->priv->start_time;
+
+  if (elapsed_time > WATCHDOG_TIMEOUT)
+    {
+      /* XXX: The way that the timeout check in Duktape is set up, it
+       * wants to bubble us all the way out of user code.
+       *
+       * The way that our test harness is set up, we need to catch a
+       * user script gone rogue... from inside... the user script...
+       * yeah, sure. To do that, "deactivate" the timeout check here
+       * after we've fired the exception. */
+      authority->priv->start_time = G_MAXINT64;
+      return 1;
+    }
+
+  return 0;
+}
diff --git a/test/data/etc/polkit-1/rules.d/10-testing.rules b/test/data/etc/polkit-1/rules.d/10-testing.rules
index 446e622..aa9d9e0 100644
--- a/test/data/etc/polkit-1/rules.d/10-testing.rules
+++ b/test/data/etc/polkit-1/rules.d/10-testing.rules
@@ -167,7 +167,7 @@ polkit.addRule(function(action, subject) {
             while (true)
                 ;
         } catch (error) {
-            if (error == "Terminating runaway script")
+            if (error == "RangeError: execution timeout")
                 return polkit.Result.YES;
             return polkit.Result.NO;
         }
-- 
1.7.9.2

